USES RDELAY,CRT;    { CRT *must* follow RDELAY ...red}

{$IFDEF VER40} TYPE DelayProc = Pointer;
{$ELSE}        TYPE DelayProc = PROCEDURE (MS: Word);
{$ENDIF}

VAR Low: Integer;
FUNCTION Tic(i: Word): Word;
BEGIN
    If i > $7FFF Then
       i := 65535 - i;
    If i < 18 Then Inc(Low);
    Tic := i;
END;

PROCEDURE Test(Name: String; Delay: DelayProc);
{$IFDEF VER40}
  PROCEDURE CallDelay(MS: WORD);
  INLINE($FF/$5E/<Delay);
{$ENDIF}
VAR ms,i,j: Word;
    t: Word Absolute $40:$6C;

BEGIN
    Writeln(#10);
    Writeln('1000ms ',Name,'.Delay should be approx 18 tics per second.');
    Writeln('Press <ESC> to skip.');
    ms  := 1000;
    Low := 0;
    REPEAT
        Write(ms:4);
        For i := 1 to 5 Do Begin
            j := t;
            while (j = t) do ;  { wait for start of new tic }
            {$IFDEF VER40}
              CallDelay(ms);
            {$ELSE}
              Delay(ms);
            {$ENDIF}
            Write(Tic(t-j-1):7);  { should be approx 18 tics per second }
            If KeyPressed Then
               If ReadKey = #27 Then
                  Exit;
        End;
        Writeln;
        Dec(ms,2);
    UNTIL Low = 5;
END;


BEGIN
    Writeln;
    {$IFDEF VER40}
       Test('RDELAY', @RDELAY.Delay);
       Test('CRT', @CRT.Delay);
    {$ELSE}
       Test('RDELAY', RDELAY.Delay);
       Test('CRT', CRT.Delay);
    {$ENDIF}
END.
